﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace TTT
{
    /// <summary>
    /// Interaction logic for ControlWindow.xaml
    /// </summary>
    public partial class ControlWindow : Window
    {
        private MainWindow parent = null;

        public ControlWindow(MainWindow parent)
        {
            this.parent = parent;
            InitializeComponent();
        }

        private void button5_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Shutdown();
        }

        public void PhidgetsAttached()
        {
            this.checkBoxManualServoControl.IsEnabled = true;

            this.labelInterfaceKitConnected.Content = "Sensor board connected";
            this.labelServoConnected.Content = "Servo controller connected";

            this.labelInterfaceKitConnected.Background = Brushes.YellowGreen;
            this.labelServoConnected.Background = Brushes.YellowGreen;

        }


        private void checkBoxManualServoControl_Checked(object sender, RoutedEventArgs e)
        {
            this.parent.SetManualArtefactControl(true);
            this.groupBox1.IsEnabled = true;
        }

        private void slider1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.parent.AdvancedServoController.servos[0].Position = 
                (double)this.slider1.Value / 10.0;
            this.labelPosition1.Content = ((double)this.slider1.Value / 10.0).ToString();
        }

        private void slider2_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.parent.AdvancedServoController.servos[1].Position =
                (double)this.slider2.Value / 10.0;
            this.labelPosition2.Content = ((double)this.slider2.Value / 10.0).ToString();
        }

        private void checkBoxManualServoControl_Unchecked(object sender, RoutedEventArgs e)
        {
            this.parent.SetManualArtefactControl(false);
            this.groupBox1.IsEnabled = false;
        }

        private void slider3_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.parent.AdvancedServoController.servos[2].Position =
                (double)this.slider3.Value / 10.0;
            this.labelPosition3.Content = ((double)this.slider3.Value / 10.0).ToString();
        }

        private void slider4_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.parent.AdvancedServoController.servos[3].Position =
                (double)this.slider4.Value / 10.0;
            this.labelPosition4.Content = ((double)this.slider4.Value / 10.0).ToString();
        }

        private void slider5_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.parent.AdvancedServoController.servos[4].Position =
                (double)this.slider5.Value / 10.0;
            this.labelPosition5.Content = ((double)this.slider5.Value / 10.0).ToString();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[0].Position = 120;
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[0].Position = 26.0;
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[1].Position = 167.0;
        }

        private void button4_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[1].Position = 180.0;
        }

        private void button6_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[2].Position = 110.0;
        }

        private void button7_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[2].Position = 50.0;
        }

        private void button8_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[3].Position = 66.0;
        }

        private void button9_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[3].Position = 2.0;
        }

        private void button10_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[4].Position = 92.0;
        }

        private void button11_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[4].Position = 38.0;
        }

        private void slider6_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.parent.AdvancedServoController.servos[5].Position =
                (double)this.slider6.Value / 10.0;
            this.labelPosition6.Content = ((double)this.slider6.Value / 10.0).ToString();
        }

        private void slider7_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.parent.AdvancedServoController.servos[6].Position =
                (double)this.slider7.Value / 10.0;
            this.labelPosition7.Content = ((double)this.slider7.Value / 10.0).ToString();
        }

        private void slider8_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.parent.AdvancedServoController.servos[7].Position =
                (double)this.slider8.Value / 10.0;
            this.labelPosition8.Content = ((double)this.slider8.Value / 10.0).ToString();
        }

        private void buttonLoadCompleteHTPSet_Click(object sender, RoutedEventArgs e)
        {
            this.buttonLoadCompleteHTPSet.IsEnabled = false;
            this.parent.InitializeOldHTPs();
        }

        private void button12_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[5].Position = 138;
        }

        private void button13_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[5].Position = 147;
        }

        private void button14_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[6].Position = 150;
        }

        private void button15_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[6].Position = 87;
        }

        private void button16_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[7].Position = 155;
        }

        private void button17_Click(object sender, RoutedEventArgs e)
        {
            this.parent.AdvancedServoController.servos[7].Position = 102;
        }
    }
}
